import { ImageStyle } from "react-native";

import { getImageContainerMarginStyles } from "@applicaster/zapp-react-native-utils/cellUtils";
import { toNumberWithDefaultZero } from "@applicaster/zapp-react-native-utils/numberUtils";

export const ImageBorderContainer = ({
  value,
  imageStyles,
}: {
  value: (key: string) => string;
  imageStyles: ImageStyle;
}) => {
  return {
    type: "BorderContainerView",
    style: {
      ...getImageContainerMarginStyles({ value }),
      position: "absolute",
      top: 0,
      zIndex: 1000,
      borderWidth: value("image_border_size"),
      borderColor: value("image_border_color"),
      borderRadius: toNumberWithDefaultZero(value("image_corner_radius")),
    },
    additionalProps: {
      borderPosition: value("image_border_position"),
      borderPaddingTop: toNumberWithDefaultZero(
        value("image_border_padding_top")
      ),
      borderPaddingRight: toNumberWithDefaultZero(
        value("image_border_padding_right")
      ),
      borderPaddingBottom: toNumberWithDefaultZero(
        value("image_border_padding_bottom")
      ),
      borderPaddingLeft: toNumberWithDefaultZero(
        value("image_border_padding_left")
      ),
    },
    elements: [
      {
        type: "View",
        style: imageStyles,
      },
    ],
  };
};
